require_relative 'mail2cb/version'
require_relative 'mail2cb/helpers'
require_relative 'mail2cb/email_body_cleanser'
require_relative 'mail2cb/email_content'
require_relative 'mail2cb/email_watcher'
require_relative 'mail2cb/email_handler'
require_relative 'mail2cb/encryption'
require_relative 'mail2cb/message_id_handler'
require 'sinatra/base'
require 'json'
require 'open3'
require 'mail'
require 'mail_daemon'

module Mail2cb
  class Handler
    def initialize
      @@watcher = EmailWatcher.new

      @@watcher.start
      Thread.abort_on_exception = true

      my_app = Sinatra.new do
        set :logging, false
        set :run, false
        set :bind, '0.0.0.0'

        get('/reload') do
          @@watcher.restart
          "OK"
        end

      end
      my_app.run!
    end
  end
end
