module Mail2cb
  class EmailContent

    def initialize(email)
      @email = email

      if @email.multipart?
        parse_parts(@email.parts)
      else
        @text_body = @email.body.decoded.force_encoding("ASCII-8BIT").encode('UTF-8', undef: :replace, replace: '')
      end
      @body = @html_body || @text_body
    end

    def parse_parts(parts)
      parts.each do |part|
        content_type = part.content_type.split(";")[0]
        if content_type == "text/html"
          @html_body = part.body.decoded.force_encoding("ASCII-8BIT").encode('UTF-8', undef: :replace, replace: '')
        elsif content_type == "text/plain"
          @text_body = part.body.decoded.force_encoding("ASCII-8BIT").encode('UTF-8', undef: :replace, replace: '')
        elsif content_type == "multipart/related"
          parse_parts(part.parts)
        end
      end
    end

    def html
      @html_body
    end

    def text
      @text_body
    end

    def body
      @body
    end
    def body=(value)
      @body = value
    end

  end
end
