module Mail2cb
  class MessageIdHandler

    def initialize(email)
      @email = email

      @content = EmailContent.new(@email)
    end

    def message_id
      from_headers || from_subject || from_body
    end

    def hash
      if message_id
        match = /([a-z]*?)\.([a-z0-9]*?)\.([a-z0-9]*?)@mail.caseblocks.com/.match(message_id)
        if match
          if match[1] == "conversation"
            {"conversation_id" => match[2]}
          elsif match[1] == "case"
            {"case_id" => match[2]}
          else
            {match[1] => match[2]}
          end
        end
      else
        {}
      end
    end

    def from_headers
      references.reverse.detect{|id| find_in_content(id) }
    end
    def from_subject
      find_in_content(@email.subject)
    end
    def from_body
      find_in_content(@content.html) || find_in_content(@content.text)
    end
    def references
      refs = @email.header["References"]
      begin
        if refs && refs.field.errors.empty?
          return refs.field.element.message_ids
        end
      rescue
        ap @email.header["References"]
      end
      []
    end

    private
    def find_in_content(content)
      match = /([a-z]*?)\.([a-z0-9]*?)\.([a-z0-9]*?)@mail.caseblocks.com/.match(content)
      if match
        match[0]
      else
        false
      end
    end

  end
end
